current_tags = [
    "52_week_high",
    "52_week_low",
    "adj_close_price",
    "adj_high_price",
    "adj_low_price",
    "adj_open_price",
    "adj_volume",
    "ask_price",
    "ask_size",
    "ask_timestamp",
    "average_daily_volume",
    "beta",
    "bid_price",
    "bid_size",
    "bid_timestamp",
    "change",
    "cik",
    "close_price",
    "company_url",
    "composite_figi",
    "composite_figi_ticker",
    "country",
    "daily_trades",
    "days_to_cover",
    "delta",
    "dividend",
    "dividend_pay_date",
    "dividend_rate",
    "employees",
    "exchange_city",
    "exchange_country",
    "exchange_name",
    "exchange_symbol",
    "ex_dividend",
    "five_yr_monthly_beta",
    "five_yr_weekly_beta",
    "high_price",
    "implied_volatility",
    "implied_volatility_change",
    "inc_country",
    "inc_state",
    "industry_category",
    "industry_group",
    "last_price",
    "last_size",
    "last_timestamp",
    "legal_name",
    "listing_exchange",
    "long_description",
    "low_price",
    "mailing_address",
    "market_category",
    "market_sector",
    "name",
    "next_day_open_interest",
    "one_yr_monthly_beta",
    "one_yr_weekly_beta",
    "open_interest",
    "open_interest_change",
    "open_price",
    "percent_change",
    "price_date",
    "price_time",
    "sector",
    "security_class",
    "security_code",
    "security_currency",
    "security_delisted",
    "security_etf",
    "security_name",
    "security_primary",
    "security_round_lot_size",
    "security_ticker",
    "security_type",
    "seven_yr_monthly_beta",
    "seven_yr_weekly_beta",
    "share_class_figi",
    "short_description",
    "short_interest",
    "sic",
    "split_ratio",
    "state",
    "stock_exchange",
    "template",
    "ten_yr_monthly_beta",
    "ten_yr_weekly_beta",
    "three_yr_monthly_beta",
    "three_yr_weekly_beta",
    "ticker",
    "volume",
]


BALANCE_SHEET_FIELD_TO_TAG = {
    "cash_and_cash_equivalents": "cashandequivalents",
    "restricted_cash": "restrictedcash",
    "short_term_investments": "shortterminvestments",
    "federal_funds_sold": "fedfundssold",
    "note_and_lease_receivable": "notereceivable",
    "interest_bearing_deposits_at_other_banks": "interestbearingdepositsatotherbanks",
    "accounts_receivable": "accountsreceivable",
    "time_deposits_placed_and_other_short_term_investments": "timedepositsplaced",
    "inventories": "netinventory",
    "trading_account_securities": "tradingaccountsecurities",
    "prepaid_expenses": "prepaidexpenses",
    "loans_and_leases": "loansandleases",
    "allowance_for_loan_and_lease_losses": "allowanceforloanandleaselosses",
    "current_deferred_refundable_income_taxes": "currentdeferredtaxassets",
    "other_current_assets": "othercurrentassets",
    "loans_and_leases_net_of_allowance": "netloansandleases",
    "other_current_non_operating_assets": "othercurrentnonoperatingassets",
    "loans_held_for_sale": "loansheldforsale",
    "total_current_assets": "totalcurrentassets",
    "accrued_investment_income": "accruedinvestmentincome",
    "plant_property_equipment_gross": "grossppe",
    "customer_and_other_receivables": "customerandotherreceivables",
    "accumulated_depreciation": "accumulateddepreciation",
    "premises_and_equipment_net": "netpremisesandequipment",
    "plant_property_equipment_net": "netppe",
    "mortgage_servicing_rights": "mortgageservicingrights",
    "long_term_investments": "longterminvestments",
    "unearned_premiums_asset": "unearnedpremiumsdebit",
    "non_current_note_lease_receivables": "noncurrentnotereceivables",
    "deferred_acquisition_cost": "deferredacquisitioncost",
    "goodwill": "goodwill",
    "separate_account_business_assets": "separateaccountbusinessassets",
    "intangible_assets": "intangibleassets",
    "non_current_deferred_refundable_income_taxes": "noncurrentdeferredtaxassets",
    "employee_benefit_assets": "employeebenefitassets",
    "other_assets": "otherassets",
    "other_non_current_operating_assets": "othernoncurrentassets",
    "total_assets": "totalassets",
    "other_non_current_non_operating_assets": "othernoncurrentnonoperatingassets",
    "non_interest_bearing_deposits": "noninterestbearingdeposits",
    "interest_bearing_deposits": "interestbearingdeposits",
    "total_non_current_assets": "totalnoncurrentassets",
    "federal_funds_purchased_and_securities_sold": "fedfundspurchased",
    "short_term_debt": "shorttermdebt",
    "bankers_acceptance_out_standing": "bankersacceptances",
    "accrued_interest_payable": "accruedinterestpayable",
    "accounts_payable": "accountspayable",
    "accrued_expenses": "accruedexpenses",
    "other_short_term_payables": "othershorttermpayables",
    "long_term_debt": "longtermdebt",
    "customer_deposits": "customerdeposits",
    "capital_lease_obligations": "capitalleaseobligations",
    "dividends_payable": "dividendspayable",
    "claims_and_claim_expense": "claimsandclaimexpenses",
    "current_deferred_revenue": "currentdeferredrevenue",
    "future_policy_benefits": "futurepolicybenefits",
    "current_deferred_payable_income_tax_liabilities": "currentdeferredtaxliabilities",
    "current_employee_benefit_liabilities": "currentemployeebenefitliabilities",
    "unearned_premiums_liability": "unearnedpremiumscredit",
    "other_taxes_payable": "othertaxespayable",
    "policy_holder_funds": "policyholderfunds",
    "other_current_liabilities": "othercurrentliabilities",
    "participating_policy_holder_equity": "participatingpolicyholderequity",
    "other_current_non_operating_liabilities": "othercurrentnonoperatingliabilities",
    "separate_account_business_liabilities": "separateaccountbusinessliabilities",
    "total_current_liabilities": "totalcurrentliabilities",
    "other_long_term_liabilities": "otherlongtermliabilities",
    "total_liabilities": "totalliabilities",
    "commitments_contingencies": "commitmentsandcontingencies",
    "asset_retirement_reserve_litigation_obligation": "assetretirementandlitigationobligation",
    "redeemable_non_controlling_interest": "redeemablenoncontrollinginterest",
    "non_current_deferred_revenue": "noncurrentdeferredrevenue",
    "preferred_stock": "totalpreferredequity",
    "common_stock": "commonequity",
    "non_current_deferred_payable_income_tax_liabilities": "noncurrentdeferredtaxliabilities",
    "non_current_employee_benefit_liabilities": "noncurrentemployeebenefitliabilities",
    "retained_earnings": "retainedearnings",
    "other_non_current_operating_liabilities": "othernoncurrentliabilities",
    "treasury_stock": "treasurystock",
    "accumulated_other_comprehensive_income": "aoci",
    "other_non_current_non_operating_liabilities": "othernoncurrentnonoperatingliabilities",
    "other_equity_adjustments": "otherequity",
    "total_non_current_liabilities": "totalnoncurrentliabilities",
    "total_common_equity": "totalcommonequity",
    "total_preferred_common_equity": "totalequity",
    "non_controlling_interest": "noncontrollinginterests",
    "total_equity_non_controlling_interests": "totalequityandnoncontrollinginterests",
    "total_liabilities_shareholders_equity": "totalliabilitiesandequity",
}


CASH_FLOW_FIELD_TO_TAG = {
    "cash_and_equivalents": "cashandequivalents",
    "acquisitions": "acquisitions",
    "amortization_expense": "amortizationexpense",
    "cash_income_taxes_paid": "cashincometaxespaid",
    "cash_interest_paid": "cashinterestpaid",
    "cash_interest_received": "cashinterestreceived",
    "depreciation_expense": "depreciationexpense",
    "divestitures": "divestitures",
    "effect_of_exchange_rate_changes": "effectofexchangeratechanges",
    "changes_in_operating_assets_and_liabilities": "increasedecreaseinoperatingcapital",
    "issuance_of_common_equity": "issuanceofcommonequity",
    "issuance_of_debt": "issuanceofdebt",
    "issuance_of_preferred_equity": "issuanceofpreferredequity",
    "loans_held_for_sale": "loansheldforsalenet",
    "net_cash_from_continuing_financing_activities": "netcashfromcontinuingfinancingactivities",
    "net_cash_from_continuing_investing_activities": "netcashfromcontinuinginvestingactivities",
    "net_cash_from_continuing_operating_activities": "netcashfromcontinuingoperatingactivities",
    "net_cash_from_discontinued_financing_activities": "netcashfromdiscontinuedfinancingactivities",
    "net_cash_from_discontinued_investing_activities": "netcashfromdiscontinuedinvestingactivities",
    "net_cash_from_discontinued_operating_activities": "netcashfromdiscontinuedoperatingactivities",
    "net_cash_from_financing_activities": "netcashfromfinancingactivities",
    "net_cash_from_investing_activities": "netcashfrominvestingactivities",
    "net_cash_from_operating_activities": "netcashfromoperatingactivities",
    "net_change_in_cash_and_equivalents": "netchangeincash",
    "net_change_in_deposits": "netchangeindeposits",
    "net_income": "netincome",
    "net_income_continuing_operations": "netincomecontinuing",
    "net_income_discontinued_operations": "netincomediscontinued",
    "net_increase_in_fed_funds_sold": "netincreaseinfedfundssold",
    "non_cash_adjustments_to_reconcile_net_income": "noncashadjustmentstonetincome",
    "other_financing_activities": "otherfinancingactivitiesnet",
    "other_investing_activities": "otherinvestingactivitiesnet",
    "other_net_changes_in_cash": "othernetchangesincash",
    "payment_of_dividends": "paymentofdividends",
    "provision_for_loan_losses": "provisionforloanlosses",
    "purchase_of_investments": "purchaseofinvestments",
    "purchase_of_investment_securities": "purchaseofinvestments",
    "purchase_of_property_plant_and_equipment": "purchaseofplantpropertyandequipment",
    "repayment_of_debt": "repaymentofdebt",
    "repurchase_of_common_equity": "repurchaseofcommonequity",
    "repurchase_of_preferred_equity": "repurchaseofpreferredequity",
    "sale_and_maturity_of_investments": "saleofinvestments",
    "sale_of_property_plant_and_equipment": "saleofplantpropertyandequipment",
}

INCOME_FIELD_TO_TAG = {
    "amortization_expense": "amortizationexpense",
    "amortizationof_deferred_policy_acquisition_costs": "amortizationofdeferredpolicyacquisitioncosts",
    "basic_and_diluted_earnings_per_share": "basicdilutedeps",
    "basic_earnings_per_share": "basiceps",
    "capitalized_lease_obligations_interest_expense": "capitalizedleaseobligationinterestexpense",
    "cash_dividends_to_common_per_share": "cashdividendspershare",
    "current_and_future_benefits": "currentandfuturebenefits",
    "depletion_expense": "depletionexpense",
    "deposits_interest_expense": "depositsinterestexpense",
    "deposits_and_money_market_investments_interest_income": "depositsinterestincome",
    "depreciation_expense": "depreciationexpense",
    "diluted_earnings_per_share": "dilutedeps",
    "exploration_expense": "explorationexpense",
    "extraordinary_income": "extraordinaryincome",
    "federal_funds_purchased_and_securities_sold_interest_expense": "fedfundsandrepointerestexpense",
    "federal_funds_sold_and_securities_borrowed_interest_income": "fedfundsandrepointerestincome",
    "impairment_charge": "impairmentexpense",
    "income_tax_expense": "incometaxexpense",
    "pre_tax_income_margin": "pretaxincomemargin",
    "investment_banking_income": "investmentbankingincome",
    "investment_securities_interest_income": "investmentsecuritiesinterestincome",
    "loans_and_leases_interest_income": "loansandleaseinterestincome",
    "long_term_debt_interest_expense": "longtermdebtinterestexpense",
    "marketing_expense": "marketingexpense",
    "consolidated_net_income": "netincome",
    "net_income_continuing_operations": "netincomecontinuing",
    "net_income_discontinued_operations": "netincomediscontinued",
    "net_income_attributable_to_common_shareholders": "netincometocommon",
    "net_income_attributable_to_noncontrolling_interest": "netincometononcontrollinginterest",
    "net_interest_income": "netinterestincome",
    "net_occupancy_and_equipment_expense": "netoccupancyequipmentexpense",
    "net_realized_and_unrealized_capital_gains_on_investments": "netrealizedcapitalgains",
    "non_operating_income": "nonoperatingincome",
    "operating_revenue": "operatingrevenue",
    "operating_cost_of_revenue": "operatingcostofrevenue",
    "other_adjustments_to_consolidated_net_income": "otheradjustmentstoconsolidatednetincome",
    "other_adjustments_to_net_income_attributable_to_common_shareholders": "otheradjustmentstonetincometocommon",
    "other_adjustment_to_net_income_attributable_to_common_shareholders": "otheradjustmentstonetincometocommon",
    "other_cost_of_revenue": "othercostofrevenue",
    "other_gains": "othergains",
    "other_income": "otherincome",
    "other_interest_expense": "otherinterestexpense",
    "other_interest_income": "otherinterestincome",
    "other_non_interest_income": "othernoninterestincome",
    "other_operating_expenses": "otheroperatingexpenses",
    "other_revenue": "otherrevenue",
    "other_service_charges": "otherservicechargeincome",
    "other_special_charges": "otherspecialcharges",
    "insurance_policy_acquisition_costs": "policyacquisitioncosts",
    "preferred_stock_dividends_declared": "preferreddividends",
    "premiums_earned": "premiumsearned",
    "property_and_liability_insurance_claims": "propertyliabilityinsuranceclaims",
    "provision_for_credit_losses": "provisionforcreditlosses",
    "research_and_development_expense": "rdexpense",
    "restructuring_charge": "restructuringcharge",
    "salaries_and_employee_benefits": "salariesandemployeebenefitsexpense",
    "service_charges_on_deposit_accounts": "servicechargesondepositsincome",
    "selling_general_and_admin_expense": "sgaexpense",
    "short_term_borrowings_interest_expense": "shorttermborrowinginterestexpense",
    "cost_of_revenue": "totalcostofrevenue",
    "gross_profit": "totalgrossprofit",
    "gross_profit_margin": "grossmargin",
    "total_interest_expense": "totalinterestexpense",
    "interest_and_investment_income": "totalinterestincome",
    "total_non_interest_expense": "totalnoninterestexpense",
    "total_non_interest_income": "totalnoninterestincome",
    "total_operating_expenses": "totaloperatingexpenses",
    "total_operating_income": "totaloperatingincome",
    "total_other_income": "totalotherincome",
    "total_pre_tax_income": "totalpretaxincome",
    "revenue": "totalrevenue",
    "trading_account_interest_income": "tradingaccountinterestincome",
    "trust_fees_by_commissions": "trustfeeincome",
    "ebit": "ebit",
    "ebitda": "ebitda",
    "ebitda_margin": "ebitdamargin",
    "weighted_average_basic_and_diluted_shares_outstanding": "weightedavebasicdilutedsharesos",
    "weighted_average_basic_shares_outstanding": "weightedavebasicsharesos",
    "weighted_average_diluted_shares_outstanding": "weightedavedilutedsharesos",
}

BALANCE_SHEET_TAG_TO_FIELD = {v: k for k, v in BALANCE_SHEET_FIELD_TO_TAG.items()}

CASH_FLOW_TAG_TO_FIELD = {v: k for k, v in CASH_FLOW_FIELD_TO_TAG.items()}

INCOME_TAG_TO_FIELD = {v: k for k, v in INCOME_FIELD_TO_TAG.items()}

new_tags = tags.get("tags")
for item in new_tags:
    item["tag"] = BALANCE_SHEET_TAG_TO_FIELD.get(item["tag"])
    item["parent"] = BALANCE_SHEET_TAG_TO_FIELD.get(item["parent"])

parent_map = []
for item in new_tags:
    parent_map.append(
        {"parent": item["parent"], "child": item["tag"], "label": item["name"]}
    )


balance_relationships = (
    df[["child", "parent"]].set_index("child").to_dict("series")["parent"].to_dict()
)
json.dumps({k: k if v is None else v for k, v in balance_relationships.items()})
